/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: org.accordproject.patent@0.2.0

// imports
import {IPostalAddress} from './org.accordproject.address@0.2.0';
import {ICountry,IPlace} from './org.accordproject.geo@0.2.0';
import {IPerson,IGender} from './org.accordproject.person@0.2.0';
import {IResidency} from './org.accordproject.usa.residency@0.2.0';
import {IConcept} from './concerto@1.0.0';

// interfaces
export interface IPatentAssetIdentifier extends IConcept {
   assetNumber: string;
   numberStatus: AssetNumberStatus;
   assetCountry?: ICountry;
}

export interface IPatentClassification extends IConcept {
   classificationSymbol?: string;
   classificationDescription?: string;
}

export interface IInventor extends IPerson {
   residentCountry?: ICountry;
   inventorResidency?: Residency;
}

export interface IApplicant extends IPerson {
}

export interface IAssignee extends IPerson {
}

export enum AssetNumberStatus {
   APP = 'APP',
   PAT = 'PAT',
   PUB = 'PUB',
   REISS = 'REISS',
   FOR = 'FOR',
}

export enum ApplicationType {
   PROV = 'PROV',
   NONPROV = 'NONPROV',
}

export enum SubjectMatter {
   UTILITY = 'UTILITY',
   PLANT = 'PLANT',
   DESIGN = 'DESIGN',
}

export interface IPatentAsset extends IConcept {
   assetIdentifier: IPatentAssetIdentifier[];
   title?: string;
   inventorIdentifier?: IInventor[];
   applicantIdentifier?: IApplicant;
   currentAssignee?: IAssignee;
   originalAssignee?: IAssignee;
   priorityDate?: Date;
   filingDate?: Date;
   issueDate?: Date;
   publicationDate?: Date;
   classifier?: IPatentClassification[];
   attorneyDocketNumber?: string;
   customerNumber?: string;
   emailAddress?: string[];
   applicationType?: ApplicationType;
   subjectMatter?: SubjectMatter;
   numDrawings?: number;
   pubFigure?: number;
   priorApplication?: IPatentAsset[];
}

